/* implémente la fonction de hachage FNV-1. source : 
https://en.wikipedia.org/wiki/Fowler%E2%80%93Noll%E2%80%93Vo_hash_function
*/

#include <stdint.h>

uint32_t fnv(unsigned char *p, uint32_t len) {
    
    const uint32_t	FNV_offset_basis = 0x811c9dc5U;
    const uint32_t	FNV_prime = 0x01000193U;
    uint32_t hash =  FNV_offset_basis;
    for(uint32_t i = 0; i<len ; i++)
	{
	    hash = hash * FNV_prime;
	    hash = hash ^ p[i];
	}
    return hash;
}
